DECLARE FUNCTION FileExist% (FileN$)
DECLARE FUNCTION CFind% (PNr%, RV%, GV%, BV%)
' ** * Palette Editor * **

DEFINT A-Z

DECLARE SUB Eerie ()

COMMON SHARED Geerie AS INTEGER, GChange AS INTEGER, GTime AS SINGLE

REDIM SHARED Pal(1 TO 3, 0 TO 255, 1 TO 3) AS INTEGER
REDIM SHARED Ps(1 TO 3) AS INTEGER, Kz(1 TO 3) AS INTEGER, Mrk(1 TO 3) AS INTEGER
REDIM SHARED FileName(1 TO 3) AS STRING
REDIM SHARED Clip(0 TO 255, 1 TO 3) AS INTEGER


SCREEN 13, 0, 0

COLOR 7
LOCATE 1, 1: PRINT "Palette Editor version 1.0"

Geerie = 32: GChange = 2: CurrKz% = 1
FileName(1) = "UNTITLED.001"
FileName(2) = "UNTITLED.002"
FileName(3) = "UNTITLED.003"
Mrk(1) = -1: Mrk(2) = -1: Mrk(3) = -1

OUT &H3C7, 0
FOR I% = 0 TO 255
Pal(1, I%, 1) = INP(&H3C9)
Pal(1, I%, 2) = INP(&H3C9)
Pal(1, I%, 3) = INP(&H3C9)
FOR J% = 2 TO 3
Pal(J%, I%, 1) = Pal(1, I%, 1)
Pal(J%, I%, 2) = Pal(1, I%, 2)
Pal(J%, I%, 3) = Pal(1, I%, 3)
NEXT J%
NEXT I%

Refresh:

IF CurrKz% < 1 THEN CurrKz% = CurrKz% + 3: GOTO Refresh
IF CurrKz% > 3 THEN CurrKz% = CurrKz% - 3: GOTO Refresh

FOR I% = 1 TO 3
Ps(I%) = Kz(I%)
COLOR 8: LOCATE I% * 3 + 1, 2: PRINT "<"; : COLOR 7: PRINT FileName(I%); : COLOR 8: PRINT ">        "
COLOR 7: LOCATE I% * 3 + 1, 30: PRINT "Color:"; Kz(I%); "  "
Q% = Ps(I%) - 40: IF Q% < 0 THEN Q% = Q% + 256
LINE (0, 9 + I% * 24)-(319, 18 + I * 24), 0, B
FOR J% = 0 TO 80
IF J% < 80 THEN
  LINE (J% * 4, 10 + I% * 24)-(J% * 4 + 3, 17 + I% * 24), I% * 80 - 64 + J%, BF
  OUT &H3C8, (I% * 80 - 64 + J%)
  OUT &H3C9, Pal(I%, Q%, 1)
  OUT &H3C9, Pal(I%, Q%, 2)
  OUT &H3C9, Pal(I%, Q%, 3)
END IF
W% = Q% - 1: IF W% < 0 THEN W% = W% + 256
W1% = Mrk(I%): W2% = Kz(I%): IF W1% > W2% THEN SWAP W1%, W2%
IF W% = Kz(I%) OR W% >= W1% AND W% <= W2% AND Mrk(I%) > -1 THEN
  E% = 14: IF I% = CurrKz% AND W% = Kz(I%) THEN E% = 15
  LINE (J% * 4 - 5, 9 + I% * 24)-(J% * 4, 18 + I% * 24), E%, B
END IF
Q% = Q% + 1: IF Q% > 255 THEN Q% = Q% - 256

NEXT J%
NEXT I%

' ** * Bars * **

OUT &H3C8, 1
OUT &H3C9, Pal(CurrKz%, Kz(CurrKz%), 1)
OUT &H3C9, 0
OUT &H3C9, 0
OUT &H3C9, 0
OUT &H3C9, Pal(CurrKz%, Kz(CurrKz%), 2)
OUT &H3C9, 0
OUT &H3C9, 0
OUT &H3C9, 0
OUT &H3C9, Pal(CurrKz%, Kz(CurrKz%), 3)


LINE (250, 100)-(257, 164), 8, B
LINE (259, 100)-(266, 164), 8, B
LINE (268, 100)-(275, 164), 8, B
LINE (248, 98)-(277, 166), 8, B
LINE (247, 97)-(278, 167), 7, B

LINE (251, 163)-(256, 101), 0, BF
IF Pal(CurrKz%, Kz(CurrKz%), 1) > 0 THEN LINE (251, 163)-(256, 164 - Pal(CurrKz%, Kz(CurrKz%), 1)), 1, BF
LINE (260, 163)-(265, 101), 0, BF
IF Pal(CurrKz%, Kz(CurrKz%), 2) > 0 THEN LINE (260, 163)-(265, 164 - Pal(CurrKz%, Kz(CurrKz%), 2)), 2, BF
LINE (269, 163)-(274, 101), 0, BF
IF Pal(CurrKz%, Kz(CurrKz%), 3) > 0 THEN LINE (269, 163)-(274, 164 - Pal(CurrKz%, Kz(CurrKz%), 3)), 3, BF

LOCATE 14, 36: COLOR 12: PRINT Pal(CurrKz%, Kz(CurrKz%), 1); " "
LOCATE 15, 36: COLOR 10: PRINT Pal(CurrKz%, Kz(CurrKz%), 2); " "
LOCATE 16, 36: COLOR 9: PRINT Pal(CurrKz%, Kz(CurrKz%), 3); " "
A$ = ""
Loop1:

Eerie
A$ = INKEY$
IF A$ = "" THEN GOTO Loop1
A$ = UCASE$(A$): IF LEN(A$) = 2 THEN A$ = "*" + RIGHT$(A$, 1)

CurrKz% = CurrKz% + (A$ = "*H") - (A$ = "*P")
IF CurrKz% < 1 THEN CurrKz% = CurrKz% + 3: GOTO Refresh
IF CurrKz% > 3 THEN CurrKz% = CurrKz% - 3: GOTO Refresh
Kz(CurrKz%) = Kz(CurrKz) + (A$ = "*K") - (A$ = "*M")
IF Kz(CurrKz%) < 0 THEN Kz(CurrKz%) = Kz(CurrKz%) + 256
IF Kz(CurrKz%) > 255 THEN Kz(CurrKz%) = Kz(CurrKz%) - 256

IF A$ = CHR$(13) THEN
  IF Mrk(CurrKz%) = -1 THEN
    Mrk(CurrKz%) = Kz(CurrKz%)
   ELSE
    Mrk(CurrKz%) = -1
  END IF
END IF

IF A$ = "C" THEN
  LOCATE 14, 2: COLOR 8: PRINT "Color:"
  B$ = "": A$ = ""
Loop2:
  LOCATE 14, 9: PRINT "      ": LOCATE 14, 9
  IF VAL(B$) > 255 THEN
    COLOR 12
    IF VAL(LEFT$(B$, 2)) > 63 THEN B$ = "63" + RIGHT$(B$, LEN(B$) - 2)
    PRINT LEFT$(B$, 2);
    COLOR 10
    IF VAL(MID$(B$, 3, 2)) > 63 THEN B$ = LEFT$(B$, 2) + "63" + RIGHT$(B$, LEN(B$) - 4)
    PRINT MID$(B$, 3, 2);
    COLOR 9
    IF VAL(MID$(B$, 5, 2)) > 63 THEN B$ = LEFT$(B$, 4) + "63"
    PRINT MID$(B$, 5, 2)
   ELSE
    COLOR 7
    PRINT B$
  END IF
  A$ = ""
  WHILE A$ = "": A$ = INKEY$: WEND
  IF A$ >= "0" AND A$ <= "9" AND LEN(B$) < 6 THEN B$ = B$ + A$
  IF A$ = CHR$(8) AND LEN(B$) > 0 THEN B$ = LEFT$(B$, LEN(B$) - 1)
  IF A$ = CHR$(27) THEN LOCATE 14, 2: PRINT "              ": GOTO Refresh
  IF A$ <> CHR$(13) THEN GOTO Loop2
  LOCATE 14, 2: PRINT "             "
  IF LEN(B$) = 0 THEN GOTO Refresh
  IF VAL(B$) > 255 THEN
    Kz(CurrKz%) = CFind%(CurrKz%, VAL(LEFT$(B$, 2)), VAL(MID$(B$, 3, 2)), VAL(MID$(B$, 5, 2)))
   ELSE
    Kz(CurrKz%) = VAL(B$)
  END IF
  GOTO Refresh
END IF

IF A$ = "O" THEN
  FOR I% = 0 TO 255: FOR J% = 1 TO 3: Clip(I%, J%) = -1: NEXT J%: NEXT I%
  IF Mrk(CurrKz%) = -1 THEN
    Clip(0, 1) = Pal(CurrKz%, Kz(CurrKz%), 1)
    Clip(0, 2) = Pal(CurrKz%, Kz(CurrKz%), 2)
    Clip(0, 3) = Pal(CurrKz%, Kz(CurrKz%), 3)
    GOTO Refresh
  END IF
  W1% = Mrk(CurrKz%): W2% = Kz(CurrKz%)
  IF W1% > W2% THEN SWAP W1%, W2%
  J% = -1
  FOR I% = W1% TO W2%
    J% = J% + 1
    Clip(J%, 1) = Pal(CurrKz%, I%, 1)
    Clip(J%, 2) = Pal(CurrKz%, I%, 2)
    Clip(J%, 3) = Pal(CurrKz%, I%, 3)
  NEXT I%
  GOTO Refresh
END IF

IF A$ = "P" THEN
  Q% = Kz(CurrKz%) - 1
  FOR I% = 0 TO 255
    Q% = Q% + 1: IF Q% > 255 THEN Q% = Q% - 256
    IF Clip(I%, 1) > -1 THEN
      Pal(CurrKz%, Q%, 1) = Clip(I%, 1)
      Pal(CurrKz%, Q%, 2) = Clip(I%, 2)
      Pal(CurrKz%, Q%, 3) = Clip(I%, 3)
    END IF
  NEXT I%
END IF


    

IF A$ = "G" AND Mrk(CurrKz%) > -1 THEN
  W1% = Mrk(CurrKz%): W2% = Kz(CurrKz%)
  IF W1% > W2% THEN SWAP W1%, W2%
  R! = Pal(CurrKz%, W1%, 1): G! = Pal(CurrKz%, W1%, 2): B! = Pal(CurrKz%, W1%, 3)
  RA! = (Pal(CurrKz%, W2%, 1) - R!) / (W2% - W1%)
  GA! = (Pal(CurrKz%, W2%, 2) - G!) / (W2% - W1%)
  BA! = (Pal(CurrKz%, W2%, 3) - B!) / (W2% - W1%)
  FOR I% = W1% TO W2%
    Pal(CurrKz%, I%, 1) = CINT(R!)
    Pal(CurrKz%, I%, 2) = CINT(G!)
    Pal(CurrKz%, I%, 3) = CINT(B!)
    R! = R! + RA!: G! = G! + GA!: B! = B! + BA!
  NEXT I%
  GOTO Refresh
END IF

IF A$ = "L" THEN GOTO Load
IF A$ = "S" THEN GOTO Save
IF A$ = "A" THEN GOTO QuickSave

IF A$ >= "1" AND A$ <= "9" THEN
  IF A$ = "7" THEN Pal(CurrKz%, Kz(CurrKz%), 1) = Pal(CurrKz%, Kz(CurrKz%), 1) + 1
  IF Pal(CurrKz%, Kz(CurrKz%), 1) > 63 THEN Pal(CurrKz%, Kz(CurrKz%), 1) = 63
  IF A$ = "4" THEN Pal(CurrKz%, Kz(CurrKz%), 1) = Pal(CurrKz%, Kz(CurrKz%), 1) - 1
  IF Pal(CurrKz%, Kz(CurrKz%), 1) < 0 THEN Pal(CurrKz%, Kz(CurrKz%), 1) = 0
  IF A$ = "8" THEN Pal(CurrKz%, Kz(CurrKz%), 2) = Pal(CurrKz%, Kz(CurrKz%), 2) + 1
  IF Pal(CurrKz%, Kz(CurrKz%), 2) > 63 THEN Pal(CurrKz%, Kz(CurrKz%), 2) = 63
  IF A$ = "5" THEN Pal(CurrKz%, Kz(CurrKz%), 2) = Pal(CurrKz%, Kz(CurrKz%), 2) - 1
  IF Pal(CurrKz%, Kz(CurrKz%), 2) < 0 THEN Pal(CurrKz%, Kz(CurrKz%), 2) = 0
  IF A$ = "9" THEN Pal(CurrKz%, Kz(CurrKz%), 3) = Pal(CurrKz%, Kz(CurrKz%), 3) + 1
  IF Pal(CurrKz%, Kz(CurrKz%), 3) > 63 THEN Pal(CurrKz%, Kz(CurrKz%), 3) = 63
  IF A$ = "6" THEN Pal(CurrKz%, Kz(CurrKz%), 3) = Pal(CurrKz%, Kz(CurrKz%), 3) - 1
  IF Pal(CurrKz%, Kz(CurrKz%), 3) < 0 THEN Pal(CurrKz%, Kz(CurrKz%), 3) = 0
  GOTO Refresh
END IF

IF A$ = "Q" THEN SYSTEM

GOTO Refresh
Load:
LOCATE 15, 2: COLOR 7: PRINT "Load:";
LINE INPUT A$
LOCATE 15, 2: PRINT SPACE$(20)
IF LEN(A$) = 0 THEN GOTO Refresh
IF FileExist%(A$) = -1 THEN GOTO Refresh

FileName(CurrKz%) = LTRIM$(RTRIM$(UCASE$(A$)))
OPEN A$ FOR INPUT AS #1
FOR I% = 1 TO 255
FOR J% = 1 TO 3
INPUT #1, Pal(CurrKz%, I%, J%)
IF LOF(1) = -1 THEN EXIT FOR: EXIT FOR
NEXT J%, I%
CLOSE #1

GOTO Refresh
Save:
LOCATE 15, 2: COLOR 7: PRINT "Save:";
LINE INPUT A$
LOCATE 15, 2: PRINT SPACE$(20)
IF LEN(A$) = 0 THEN GOTO Refresh

FileName(CurrKz%) = LTRIM$(RTRIM$(UCASE$(A$)))
OPEN A$ FOR OUTPUT AS #1
FOR I% = 1 TO 255
FOR J% = 1 TO 3
PRINT #1, Pal(CurrKz%, I%, J%);
NEXT J%: PRINT #1, ""
NEXT I%
CLOSE #1

GOTO Refresh
QuickSave:
OPEN FileName(CurrKz%) FOR OUTPUT AS #1
FOR I% = 0 TO 255
FOR J% = 1 TO 3
PRINT #1, Pal(CurrKz%, I%, J%);
NEXT J%: PRINT #1, ""
NEXT I%
CLOSE #1

GOTO Refresh

FUNCTION CFind% (PNr%, RV%, GV%, BV%)

CF1% = 0: CF2% = 10000
FOR I% = 0 TO 255
  CF3% = ABS(Pal(PNr%, I%, 1) - RV%) + ABS(Pal(PNr%, I%, 2) - GV%) + ABS(Pal(PNr%, I%, 3) - BV%)
  IF CF3% < CF2% THEN CF1% = I%: CF2% = CF3%
NEXT I%
CFind% = CF1%

END FUNCTION

SUB Eerie

IF GTime = TIMER THEN EXIT SUB
GTime = TIMER

Geerie = Geerie + GChange
IF Geerie >= 63 THEN GChange = -2
IF Geerie > 63 THEN Geerie = 63
IF Geerie < 22 THEN GChange = 2

Geerie2 = INT(Geerie * .5)
OUT &H3C8, 14
OUT &H3C9, Geerie2
OUT &H3C9, Geerie2
OUT &H3C9, Geerie2
OUT &H3C9, 0
OUT &H3C9, Geerie
OUT &H3C9, 0



END SUB

FUNCTION FileExist% (FileN$)

FF% = FREEFILE

OPEN FileN$ FOR BINARY AS #1
  D! = LOF(1)
CLOSE #1

IF D! = 0 THEN
  KILL FileN$
  FileExist% = -1: EXIT FUNCTION
 ELSE
  FileExist% = 0: EXIT FUNCTION
END IF


END FUNCTION

